<?php

namespace Drupal\user_mail_control\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

/**
 * Class UserEmailRequiredDisabledValidator.
 *
 * @package Drupal\user_mail_control\Plugin\Validation\Constraint
 */
class UserMailRequiredDisabledValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($items, Constraint $constraint) {
    /** @var \Drupal\Core\Field\FieldItemListInterface $items */

    $values = $items->getValue();
    if ((empty($values['value']))) {
      return;
    }

    $violations = $items->getEntity()->validate();
    foreach ($violations as $violation) {
      // Add the reason for the validation failure to the current context.
      $this->context->buildViolation($constraint->message)->addViolation();
    }
  }

}
